package core;

import java.io.File;
import java.net.URL;
import java.util.ArrayList;
import plugins.Plugin;

public class PluginHandler {
	@SuppressWarnings("unchecked")
	public static Class<Plugin>[] getClasses(String pckgname)
	throws ClassNotFoundException {
		ArrayList<Class<Plugin>> classes = new ArrayList<Class<Plugin>>();
		// Pega um objeto File para o pacote
		File directory = null;
		try {
			ClassLoader cld = Thread.currentThread().getContextClassLoader();
			if (cld == null) {
				throw new ClassNotFoundException("Não foi possível pegar o ClassLoader.");
			}
			String path = pckgname.replace('.', '/');
			URL resource = cld.getResource(path);
			if (resource == null) {
				throw new ClassNotFoundException("Nenhum recurso para " + path);
			}
			directory = new File(resource.getFile());
		} catch (NullPointerException x) {
			throw new ClassNotFoundException(pckgname + " (" + directory
					+ ") parece não ser um pacote válido");
		}
		if (directory.exists()) {
			// Pega a lista de arquivos contidos nesse pacote
			String[] files = directory.list();
			for (int i = 0; i < files.length; i++) {
				// queremos apenas os arquivos .class 
				if (files[i].endsWith(".class")) {
					// remove a extensão .class
					try {
						classes.add((Class<Plugin>) Class.forName(pckgname + '.'
							+ files[i].substring(0, files[i].length() - 6)));
					} catch (ClassCastException e) {
						throw new ClassNotFoundException(pckgname + "." + files[i].substring(0, files[i].length() - 6)
								+ " não extende a interface Plugin.");
					}
				}
			}
		} else {
			throw new ClassNotFoundException(pckgname
					+ " não parece ser um pacote válido");
		}
		Class<Plugin>[] classesA = new Class[classes.size()];
		classes.toArray(classesA);
		return classesA;
	}
}